package biggests.utils;

import java.awt.Component;
import java.awt.Graphics2D;
import java.awt.Graphics;
import javax.swing.Icon;
import javax.swing.JScrollPane;
import javax.swing.JPanel;

/**
 * <p>Title: Vertical Text Icon With Arrow</p>
 *
 * <p>Description: Implements an icon with vertical text and an arrow.</p>
 *
 * <p>Copyright: Copyright (c) 2008</p>
 *
 * <p>Copyright:   Copyright (C) 2007  Joana P. Gonalves
 *                 This program is free software; you can redistribute
 *                 it and/or modify it under the terms of the GNU General
 *                 Public License as published by the Free Software
 *                 Foundation; either version 3 of the License, or
 *                 any later version.
 *
 *                 This program is distributed in the hope that it will
 *                 be useful, but WITHOUT ANY WARRANTY; without even the
 *                 implied warranty of MERCHANTABILITY or FITNESS FOR A
 *                 PARTICULAR PURPOSE.  See the
 *                 <a href="http://www.gnu.org/licenses/gpl.html">
 *                 GNU General Public License</a> for more details.
 * </p>
 *
 * @author Joana P. Gonalves
 * @version 1.0
 */
public class VerticalTextIconWithArrow extends VerticalTextIcon {
    Icon arrow;

    public VerticalTextIconWithArrow(Icon arrow, Component component, String label) {
        super(component, label);
        this.arrow = arrow;
    }

    public VerticalTextIconWithArrow(Icon arrow, Component component, String label, int rotateHint) {
        super(component, label, rotateHint);
        this.arrow = arrow;
    }

    /**
     * Draws the icon at the specified location. Icon implementations
     * may use the Component argument to get properties useful for
     * painting, e.g. the foreground or background color.
     *
     * @param c the <code>Component</code> to draw
     * @param g the <code>Graphics</code> where to draw the <code>component</code>
     * @param x int the x-coordinate of the <code>component</code>'s location
     * @param y int the y-coordinate of the <code>component</code>'s location
     */
    public void paintIcon(Component c, Graphics g, int x, int y) {
        super.paintIcon(c, g, x, y);
        if (arrow != null) {
            arrow.paintIcon(c, g, x+2, y-5);
        }
    }
}
